function h = oe_entropy(data)
%OE_ENTROPY Estimates the entropy of random variables.
%   H = OE_ENTROPY(DATA) returns a vetor of the estimated 
%   entropies. DATA is a matrix containing the R.V.s samples
%   (Each line represents the samples of a single R.V.)
%
% Suyama/Leo (14/07/2005)

[Nsources, Nsamples]= size(data);
Nbins = 20;  % # de divisoes no intervalo ]0,1[

u = linspace(1e-12,1-1e-12,Nbins);
delta = u(2)-u(1);

ordered_data = sort(data,2);

index = ceil(Nsamples*u/u(end));

aux = ordered_data(:,index(2:end)) - ordered_data(:,index(1:end-1));
h = sum(log(aux/delta)*(delta/(u(end)-u(1))),2);